<?php
/*
Plugin Name: Add new brushes to WP SyntaxHighlighter
Plugin URI: http://www.near-mint.com/blog/software
Description: This plugin will add new languages to "WP SyntaxHighlighter" plugin.
Version: 1.0.2
Author: Redcocker
Author URI: http://www.near-mint.com/blog/
*/

$adnb_wpsh_plugin_url = plugin_dir_url( __FILE__ );

//Add addtional brush files for SyntaxHighlighter ver.3.0.
//You should change function name to unique one.
function ab_wpsh_add_v3_brushes() {
	global $adnb_wpsh_plugin_url;
//	echo '		,"Aliases(space-delimited)	Brush files URL"';
//	echo "\n";
	echo '	,"bat batch cmd	'.$adnb_wpsh_plugin_url.'scripts3/shBrushBat.js?ver=3.0"';
	echo "\n";
	echo '	,"clojure Clojure clj	'.$adnb_wpsh_plugin_url.'scripts3/shBrushClojure.js?ver=3.0"';
	echo "\n";
	echo '	,"latex tex	'.$adnb_wpsh_plugin_url.'scripts3/shBrushLatex.js?ver=3.0"';
	echo "\n";
//Put "shBrushBat.js", "shBrushClojure.js" and "shBrushLatex.js" brush files in "scripts3" directry.
}

//Add addtional brush files for SyntaxHighlighter ver.2.1.
//You should change function name to unique one.
function ab_wpsh_add_v2_brushes() {
	global $adnb_wpsh_plugin_url;
//	echo '<script type="text/javascript" src="[Brush files URL]"></script>';
//	echo "\n";
	echo '<script type="text/javascript" src="'.$adnb_wpsh_plugin_url.'scripts2/shBrushBat.js?ver=2.1"></script>';
	echo "\n";
	echo '<script type="text/javascript" src="'.$adnb_wpsh_plugin_url.'scripts2/shBrushClojure.js?ver=2.1"></script>';
	echo "\n";
	echo '<script type="text/javascript" src="'.$adnb_wpsh_plugin_url.'scripts2/shBrushLatex.js?ver=2.1"></script>';
	echo "\n";
//Put "shBrushBat.js", "shBrushClojure.js" and "shBrushLatex.js" brush files in "scripts2" directry.
}

//Add to action hooks.
//You should modify in response to new function name.
add_action('wpsh_brush_for_3', 'ab_wpsh_add_v3_brushes');
add_action('wpsh_brush_for_2', 'ab_wpsh_add_v2_brushes');

//Add your language to buttons  in SyntaxHighlighter ver.3.0.
$wp_sh_language3 = get_option('wp_sh_language3');
//$wp_sh_language3['Alias'] = array('Language name', 'added');
$wp_sh_language3['batch'] = array('Batch', 'added');
$wp_sh_language3['clojure'] = array('Clojure', 'added');
$wp_sh_language3['latex'] = array('Latex', 'added');
update_option('wp_sh_language3', $wp_sh_language3);

//Add your language to buttons in SyntaxHighlighter ver.2.1.
$wp_sh_language2 = get_option('wp_sh_language2');
//$wp_sh_language2['Alias'] = array('Language name', 'added');
$wp_sh_language2['batch'] = array('Batch', 'added');
$wp_sh_language2['clojure'] = array('Clojure', 'added');
$wp_sh_language2['latex'] = array('Latex', 'added');
update_option('wp_sh_language2', $wp_sh_language2);

//When deactivated this plugin, added language will be cleared.
//You should change function name to unique one.
function ab_wpsh_deactive() {
	$wp_sh_language3_unset = get_option('wp_sh_language3');
//	unset($wp_sh_language3_unset['Alias']);
	unset($wp_sh_language3_unset['batch']);
	unset($wp_sh_language3_unset['clojure']);
	unset($wp_sh_language3_unset['latex']);
	$wp_sh_language2_unset = get_option('wp_sh_language2');
//	unset($wp_sh_language2_unset['Alias']);
	unset($wp_sh_language2_unset['batch']);
	unset($wp_sh_language2_unset['clojure']);
	unset($wp_sh_language2_unset['latex']);
	update_option('wp_sh_language3', $wp_sh_language3_unset);
	update_option('wp_sh_language2', $wp_sh_language2_unset);
}
register_deactivation_hook(__FILE__, 'ab_wpsh_deactive'); 

?>