<?php
/*
Plugin Name: WP SyntaxHighlighter
Plugin URI: http://www.near-mint.com/blog/software
Description: This plugin is code syntax highlighter based on <a href="http://alexgorbatchev.com/SyntaxHighlighter/">SyntaxHighlighter</a> ver. 3.0.83 and ver. 2.1.382. Supported languages: Bash, C++, CSS, Delphi, Java, JavaScript, Perl, PHP, Python, Ruby, SQL, VB, XML, XHTML and HTML etc.
Version: 1.3.8.1
Author: redcocker
Author URI: http://www.near-mint.com/blog/
Text Domain: wp_sh
Domain Path: /locale/
*/
/* 
Date of release: Ver. 1.3.8.1 2011/6/27
Includes: SyntaxHighlighter ver. 3.0.83 and ver. 2.1.382 licensed under the MIT and LGPL v3. My modified 'SyntaxHighlighter TinyMCE Button' licensed under the GPL v2.
License: GPL v2(Except 'SyntaxHighlighter' libraries)
*/
/*  Copyright 2011 M. Sumitomo

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
load_plugin_textdomain('wp_sh', false, 'wp-syntaxhighlighter/locale');
$wp_sh_ver = "1.3.8.1";
$wp_sh_db_ver = "1.3";
$wp_sh_plugin_url = plugin_dir_url( __FILE__ );
$version = get_option('wp_sh_version');
if ($version == "3.0") {
	$lib_dir = 'syntaxhighlighter3';
} elseif ($version == "2.1") {
	$lib_dir = 'syntaxhighlighter2';
}

//Define the associative arrays
function wp_sh_array_setting(){
	global $wp_sh_db_ver;
	//Languages for ver. 3.0 assign to the associative array
	$wp_sh_pre_language3 = get_option('wp_sh_language3');
	if (is_array($wp_sh_pre_language3)) {
		$wp_sh_language3 = $wp_sh_pre_language3;
	}
	$wp_sh_language3 = get_option('wp_sh_language3');
	$wp_sh_language3['applescript'] = array('AppleScript', 'true');
	$wp_sh_language3['actionscript3'] = array('Actionscript3', 'true');
	$wp_sh_language3['bash'] = array('Bash shell', 'true');
	$wp_sh_language3['coldfusion'] = array('ColdFusion', 'true');
	$wp_sh_language3['c'] = array('C', 'true');
	$wp_sh_language3['cpp'] = array('C++', 'true');
	$wp_sh_language3['csharp'] = array('C#', 'true');
	$wp_sh_language3['css'] = array('CSS', 'true');
	$wp_sh_language3['delphi'] = array('Delphi', 'true');
	$wp_sh_language3['diff'] = array('Diff', 'true');
	$wp_sh_language3['erlang'] = array('Erlang', 'true');
	$wp_sh_language3['groovy'] = array('Groovy', 'true');
	$wp_sh_language3['html'] = array('HTML', 'true');
	$wp_sh_language3['java'] = array('Java', 'true');
	$wp_sh_language3['javafx'] = array('JavaFX', 'true');
	$wp_sh_language3['javascript'] = array('JavaScript', 'true');
	$wp_sh_language3['pascal'] = array('Pascal', 'true');
	$wp_sh_language3['patch'] = array('Patch', 'true');
	$wp_sh_language3['perl'] = array('Perl', 'true');
	$wp_sh_language3['php'] = array('PHP', 'true');
	$wp_sh_language3['text'] = array('Plain Text', 'true');
	$wp_sh_language3['powershell'] = array('PowerShell', 'true');
	$wp_sh_language3['python'] = array('Python', 'true');
	$wp_sh_language3['ruby'] = array('Ruby', 'true');
	$wp_sh_language3['rails'] = array('Ruby on Rails', 'true');
	$wp_sh_language3['sass'] = array('Sass', 'true');
	$wp_sh_language3['scala'] = array('Scala', 'true');
	$wp_sh_language3['scss'] = array('Scss', 'true');
	$wp_sh_language3['shell'] = array('Shell', 'true');
	$wp_sh_language3['sql'] = array('SQL', 'true');
	$wp_sh_language3['vb'] = array('Visual Basic', 'true');
	$wp_sh_language3['vbnet'] = array('Visual Basic .NET', 'true');
	$wp_sh_language3['xhtml'] = array('XHTML', 'true');
	$wp_sh_language3['xml'] = array('XML', 'true');
	$wp_sh_language3['xslt'] = array('XSLT', 'true');
	//Languages for ver. 2.1 assign to the associative array
	$wp_sh_pre_language2 = get_option('wp_sh_language2');
	if (is_array($wp_sh_pre_language2)) {
		$wp_sh_language2 = $wp_sh_pre_language2;
	}
	$wp_sh_language2['actionscript3'] = array('Actionscript3', 'true');
	$wp_sh_language2['bash'] = array('Bash shell', 'true');
	$wp_sh_language2['coldfusion'] = array('ColdFusion', 'true');
	$wp_sh_language2['c'] = array('C', 'true');
	$wp_sh_language2['cpp'] = array('C++', 'true');
	$wp_sh_language2['csharp'] = array('C#', 'true');
	$wp_sh_language2['css'] = array('CSS', 'true');
	$wp_sh_language2['delphi'] = array('Delphi', 'true');
	$wp_sh_language2['diff'] = array('Diff', 'true');
	$wp_sh_language2['erlang'] = array('Erlang', 'true');
	$wp_sh_language2['groovy'] = array('Groovy', 'true');
	$wp_sh_language2['html'] = array('HTML', 'true');
	$wp_sh_language2['java'] = array('Java', 'true');
	$wp_sh_language2['javafx'] = array('JavaFX', 'true');
	$wp_sh_language2['javascript'] = array('JavaScript', 'true');
	$wp_sh_language2['pascal'] = array('Pascal', 'true');
	$wp_sh_language2['patch'] = array('Patch', 'true');
	$wp_sh_language2['perl'] = array('Perl', 'true');
	$wp_sh_language2['php'] = array('PHP', 'true');
	$wp_sh_language2['text'] = array('Plain Text', 'true');
	$wp_sh_language2['powershell'] = array('PowerShell', 'true');
	$wp_sh_language2['python'] = array('Python', 'true');
	$wp_sh_language2['ruby'] = array('Ruby', 'true');
	$wp_sh_language2['rails'] = array('Ruby on Rails', 'true');
	$wp_sh_language2['scala'] = array('Scala', 'true');
	$wp_sh_language2['shell'] = array('Shell', 'true');
	$wp_sh_language2['sql'] = array('SQL', 'true');
	$wp_sh_language2['vb'] = array('Visual Basic', 'true');
	$wp_sh_language2['vbnet'] = array('Visual Basic .NET', 'true');
	$wp_sh_language2['xhtml'] = array('XHTML', 'true');
	$wp_sh_language2['xml'] = array('XML', 'true');
	$wp_sh_language2['xslt'] = array('XSLT', 'true');
	//Brush files for ver. 2.1 assign to the associative array
	$wp_sh_brush_files['AppleScript'] = array('shBrushAppleScript.js', 'applescript', '3.0', 'true');
	$wp_sh_brush_files['ActionScript3'] = array('shBrushAS3.js', 'as3 actionscript3', '2.1', 'true');
	$wp_sh_brush_files['Bash'] = array('shBrushBash.js', 'bash shell', '2.1', 'true');
	$wp_sh_brush_files['ColdFusion'] = array('shBrushColdFusion.js', 'cf coldfusion', '2.1', 'true');
	$wp_sh_brush_files['C++'] = array('shBrushCpp.js', 'cpp c', '1.5', 'true');
	$wp_sh_brush_files['C#'] = array('shBrushCSharp.js', 'c# c-sharp csharp', '1.5', 'true');
	$wp_sh_brush_files['CSS'] = array('shBrushCss.js', 'css', '1.5', 'true');
	$wp_sh_brush_files['Delphi'] = array('shBrushDelphi.js', 'delphi pas pascal', '1.5', 'true');
	$wp_sh_brush_files['Diff'] = array('shBrushDiff.js', 'diff patch', '2.1', 'true');
	$wp_sh_brush_files['Erlang'] = array('shBrushErlang.js', 'erl erlang', '2.1', 'true');
	$wp_sh_brush_files['Groovy'] = array('shBrushGroovy.js', 'groovy', '2.1', 'true');
	$wp_sh_brush_files['Java'] = array('shBrushJava.js', 'java', '1.5', 'true');
	$wp_sh_brush_files['JavaFX'] = array('shBrushJavaFX.js', 'jfx javafx', '2.1', 'true');
	$wp_sh_brush_files['JavaScript'] = array('shBrushJScript.js', 'js jscript javascript', '1.5', 'true');
	$wp_sh_brush_files['Perl'] = array('shBrushPerl.js', 'perl pl', '2.1', 'true');
	$wp_sh_brush_files['PHP'] = array('shBrushPhp.js', 'php', '1.5', 'true');
	$wp_sh_brush_files['PlainText'] = array('shBrushPlain.js', 'plain text', '2.1', 'true');
	$wp_sh_brush_files['PowerShell'] = array('shBrushPowerShell.js', 'ps powershell', '2.1', 'true');
	$wp_sh_brush_files['Python'] = array('shBrushPython.js', 'py python', '1.5', 'true');
	$wp_sh_brush_files['Ruby'] = array('shBrushRuby.js', 'rails ror ruby rb', '1.5', 'true');
	$wp_sh_brush_files['Sass'] = array('shBrushSass.js', 'sass scss', '3.0', 'true');
	$wp_sh_brush_files['Scala'] = array('shBrushScala.js', 'scala', '2.1', 'true');
	$wp_sh_brush_files['SQL'] = array('shBrushSql.js', 'sql', '1.5', 'true');
	$wp_sh_brush_files['VisualBasic'] = array('shBrushVb.js', 'vb vbnet', '1.5', 'true');
	$wp_sh_brush_files['XML'] = array('shBrushXml.js', 'xml xhtml xslt html', '1.5', 'true');

	update_option('wp_sh_language3', $wp_sh_language3);
	update_option('wp_sh_language2', $wp_sh_language2);
	update_option('wp_sh_brush_files', $wp_sh_brush_files);
	update_option('wp_sh_checkver_stamp', $wp_sh_db_ver);
}

//Check DB table version and create table
add_action('plugins_loaded', 'wp_sh_check_db_ver');

function wp_sh_check_db_ver(){
	global $wp_sh_db_ver;
	if ($wp_sh_db_ver != get_option('wp_sh_checkver_stamp')) {
		wp_sh_array_setting();
	}
}

//Footer on setting menu
function wp_sh_add_admin_footer(){ //show plugin info in the footer
	$plugin_data = get_plugin_data(__FILE__);
	printf('%1$s by %2$s<br />', $plugin_data['Title'].' '.$plugin_data['Version'], $plugin_data['Author']);
}

//Add setting menu and variable values
add_action('admin_menu', 'wp_sh_register_menu_item');

function wp_sh_register_menu_item() {
	$addl_style = '.syntaxhighlighter,
.syntaxhighlighter a,
.syntaxhighlighter div,
.syntaxhighlighter code,
.syntaxhighlighter table,
.syntaxhighlighter table td,
.syntaxhighlighter table tr,
.syntaxhighlighter table tbody,
.syntaxhighlighter table thead,
.syntaxhighlighter table caption,
.syntaxhighlighter textarea {
font-size: 12px !important; /* set the font size in pixels */
font-family: "Consolas", "Bitstream Vera Sans Mono", "Courier New", Courier, monospace !important; /* set the font type */
}
.syntaxhighlighter.nogutter td.code .line {
padding-left: 3px !important; /* set the left padding space when no-gutter */
}';
	register_setting( 'wp_sh_settings_group', 'wp_sh_version');
	register_setting( 'wp_sh_settings_group', 'wp_sh_theme');
	register_setting( 'wp_sh_settings_group', 'wp_sh_auto_links');
	register_setting( 'wp_sh_settings_group', 'wp_sh_class_name');
	register_setting( 'wp_sh_settings_group', 'wp_sh_addl_style_enable');
	register_setting( 'wp_sh_settings_group', 'wp_sh_addl_style');
	register_setting( 'wp_sh_settings_group', 'wp_sh_collapse');
	register_setting( 'wp_sh_settings_group', 'wp_sh_gutter');
	register_setting( 'wp_sh_settings_group', 'wp_sh_first_line');
	register_setting( 'wp_sh_settings_group', 'wp_sh_smart_tabs');
	register_setting( 'wp_sh_settings_group', 'wp_sh_tab_size');
	register_setting( 'wp_sh_settings_group', 'wp_sh_toolbar');
	register_setting( 'wp_sh_settings_group', 'wp_sh_wrap');
	register_setting( 'wp_sh_settings_group', 'wp_sh_legacy');
	register_setting( 'wp_sh_settings_group', 'wp_sh_css');
	register_setting( 'wp_sh_settings_group', 'wp_sh_insert');
	register_setting( 'wp_sh_settings_group', 'wp_sh_codebox');
	register_setting( 'wp_sh_settings_group', 'wp_sh_button_window_size');
	register_setting( 'wp_sh_settings_group', 'wp_sh_button_row');
	add_option('wp_sh_version', '3.0');
	add_option('wp_sh_theme', 'Default');
	add_option('wp_sh_auto_links', 1);
	add_option('wp_sh_class_name', '');
	add_option('wp_sh_addl_style_enable', 0);
	add_option('wp_sh_addl_style', $addl_style);
	add_option('wp_sh_collapse', 0);
	add_option('wp_sh_gutter', 1);
	add_option('wp_sh_first_line', '1');
	add_option('wp_sh_smart_tabs', 1);
	add_option('wp_sh_tab_size', '4');
	add_option('wp_sh_toolbar', 1);
	add_option('wp_sh_wrap', 0);
	add_option('wp_sh_legacy', 0);
	add_option('wp_sh_css', 0);
	add_option('wp_sh_insert', 1);
	add_option('wp_sh_codebox', 1);
	add_option('wp_sh_button_window_size', '100');
	add_option('wp_sh_button_row', '1');
	add_options_page('WP SyntaxHighlighter Options', 'WP SyntaxHighlighter', 'manage_options', 'wp-syntaxhighlighter-options', 'wp_sh_options_panel');
}

//Add link to setting menu
add_filter( 'plugin_action_links', 'wp_sh_setting_link', 10, 2 );

function wp_sh_setting_link( $links, $file ){
	static $this_plugin;
	if ( ! $this_plugin ) $this_plugin = plugin_basename(__FILE__);
	if ( $file == $this_plugin ){
		$settings_link = '<a href="options-general.php?page=wp-syntaxhighlighter-options">'.__('Settings', 'wp_sh').'</a>';
		array_unshift( $links, $settings_link );
	}  
	return $links;
} 

//Load SyntaxHighlighter TinyMCE Button
if (get_option('wp_sh_insert') == 1) {
	include_once('sh-tinymce-button-ins/sh-tinymce-button-ins.php');
}
if (get_option('wp_sh_codebox') == 1) {
	include_once('sh-tinymce-button-box/sh-tinymce-button-box.php');
}

// Allow tab to indent in tinyMCE.
if (get_option('wp_sh_insert') == 1 || get_option('wp_sh_codebox') == 1) {
	add_filter('tiny_mce_before_init', 'wp_sh_shtb_allow_tab');
}

function wp_sh_shtb_allow_tab($initArray) {
    $initArray['plugins']=preg_replace("|[,]+tabfocus|i","",$initArray['plugins']);
    return $initArray;
}

// Add tags and attribtes as TinyMCE valid_elements.
add_filter('tiny_mce_before_init', 'wp_sh_shtb_mce_valid_elements');

function wp_sh_shtb_mce_valid_elements($init) {
	if ( isset( $init['extended_valid_elements'] ) 
	&& ! empty( $init['extended_valid_elements'] ) ) {
		$init['extended_valid_elements'] .= ',' . 'pre[name|class]';
		$init['extended_valid_elements'] .= ',' . 'textarea[name|class|cols|rows]';
	} else {
		$init['extended_valid_elements'] = 'pre[name|class]';
		$init['extended_valid_elements'] .= ',' . 'textarea[name|class|cols|rows]';
	}
	return $init;
}

//Load additional style sheet
if (get_option('wp_sh_addl_style_enable') == 1) {
	add_action('wp_head', 'wp_sh_load_addl_style');
}
add_action('admin_head', 'wp_sh_load_addl_style');

function wp_sh_load_addl_style(){
	global $wp_sh_ver;
	if (is_home() || is_admin() || is_singular()) {
		echo "\n<!-- WP SyntaxHighlighter Ver.".$wp_sh_ver." CSS for code Begin -->\n";
		echo "<style type='text/css'>\n".get_option('wp_sh_addl_style')."\n</style>\n";
		echo "<!-- WP SyntaxHighlighter Ver.".$wp_sh_ver." CSS for code End -->\n";
	}
}

//Load css on header
add_action('wp_print_styles', 'wp_sh_load_style');
add_action('admin_print_styles', 'wp_sh_load_style');

function wp_sh_load_style(){
	global $wp_sh_plugin_url, $version, $lib_dir;
	$theme = get_option('wp_sh_theme');
	if (is_home() || is_admin() || is_singular()) {
		if (get_option('wp_sh_css') == 1) {
			wp_enqueue_style('pre_css', $wp_sh_plugin_url.'pre.css', false, '1.0');
		}
		wp_enqueue_style('core'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shCore.css', false, $version);
		if ($theme == "Default") {
			if ($version == "3.0") {
				wp_enqueue_style('core-default'.$version, $wp_sh_plugin_url.$lib_dir.'styles/shCoreDefault.css', false, $version);
			}
			wp_enqueue_style('theme-default'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shThemeDefault.css', false, $version);
		}
		if ($theme == "Django") {
			if ($version == "3.0") {
				wp_enqueue_style('core-django'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shCoreDjango.css', false, $version);
			}
			wp_enqueue_style('theme-django'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shThemeDjango.css', false, $version);
		}
		if ($theme == "Eclipse") {
			if ($version == "3.0") {
				wp_enqueue_style('core-eclipse'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shCoreEclipse.css', false, $version);
			}
			wp_enqueue_style('theme-eclipse'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shThemeEclipse.css', false, $version);
		}
		if ($theme == "Emacs") {
			if ($version == "3.0") {
				wp_enqueue_style('core-emacs'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shCoreEmacs.css', false , $version);
			}
			wp_enqueue_style('theme-emacs'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shThemeEmacs.css', false, $version);
		}
		if ($theme == "FadeToGrey") {
			if ($version == "3.0") {
				wp_enqueue_style('core-fadetogrey'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shCoreFadeToGrey.css', false, $version);
			}
			wp_enqueue_style('theme-fadetogrey'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shThemeFadeToGrey.css', false, $version);
		}
		if ($theme == "MDUltra") {
			if ($version == "3.0") {
				wp_enqueue_style('core-mdultra'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shCoreMDUltra.css', false, $version);
				wp_enqueue_style('theme-mdultra'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shThemeMDUltra.css', false, $version);
			} elseif ($version == "2.1") {
				update_option('wp_sh_theme', 'Default');
				wp_enqueue_style('theme-default'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shThemeDefault.css', false, $version);
			}
		}
		if ($theme == "Midnight") {
			if ($version == "3.0") {
				wp_enqueue_style('core-midnight'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shCoreMidnight.css', false, $version);
			}
			wp_enqueue_style('theme-midnight'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shThemeMidnight.css', false, $version);
		}
		if ($theme == "RDark") {
			if ($version == "3.0") {
				wp_enqueue_style('core-rdark'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shCoreRDark.css', false, $version);
			}
			wp_enqueue_style('theme-rdark'.$version, $wp_sh_plugin_url.$lib_dir.'/styles/shThemeRDark.css', false, $version);
		}
	}
}

//Load javascript in admin menu
add_action('admin_print_scripts', 'wp_sh_load_jscript_for_admin');

function wp_sh_load_jscript_for_admin(){
	global $wp_sh_plugin_url;
	wp_enqueue_script('rc_admin_js', $wp_sh_plugin_url.'rc-admin-js.js', false, '1.1');
}

//Load scripts on footer
add_action('wp_footer', 'wp_sh_load_scripts_on_footer');
add_action('admin_footer', 'wp_sh_load_scripts_on_footer');

function wp_sh_load_scripts_on_footer(){
	global $wp_sh_ver, $wp_sh_plugin_url, $version, $lib_dir;
	$post = get_the_content();
	if ((preg_match("/<pre[^>]*?brush:[^>]*?>/i", $post) && !is_archive()) || (preg_match("/<script[^>]*?type=['\"]syntaxhighlighter['\"][^>]*?>/i", $post) && !is_archive()) || (preg_match("/<[(pre)(textarea)][^>]*?name=['\"]code['\"][^>]*?>/i", $post) && !is_archive() && get_option('wp_sh_legacy') == 1) || is_home() || is_admin()) {
		if (get_option('wp_sh_auto_links') == 0) {
			$auto_links = 'false';
		} elseif (get_option('wp_sh_auto_links') == 1) {
			$auto_links = 'true';
		}
		if (get_option('wp_sh_collapse') == 0) {
			$collapse = 'false';
		} elseif (get_option('wp_sh_collapse') == 1) {
			$collapse = 'true';
		}
		if (get_option('wp_sh_gutter') == 0) {
			$gutter = 'false';
		} elseif (get_option('wp_sh_gutter') == 1) {
			$gutter = 'true';
		}
		if (get_option('wp_sh_smart_tabs') == 0) {
			$smart_tabs = 'false';
		} elseif (get_option('wp_sh_smart_tabs') == 1) {
			$smart_tabs = 'true';
		}
		if (get_option('wp_sh_toolbar') == 0) {
			$toolbar = 'false';
		} elseif (get_option('wp_sh_toolbar') == 1) {
			$toolbar = 'true';
		}
		if (get_option('wp_sh_wrap') == 0) {
			$wrap = 'false';
		} elseif (get_option('wp_sh_wrap') == 1) {
			$wrap = 'true';
		}
		if (get_option('wp_sh_legacy') == 0) {
			$legacy = '';
		} elseif (get_option('wp_sh_legacy') == 1) {
			$legacy = "dp.SyntaxHighlighter.HighlightAll('code')";
		}
		echo "\n<!-- WP SyntaxHighlighter Ver.".$wp_sh_ver." Begin -->\n";
		echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shCore.js?ver=\".$version></script>\n";
		if (get_option('wp_sh_legacy') == 0) {
			echo '';
		} elseif (get_option('wp_sh_legacy') == 1) {
			echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shLegacy.js?ver=".$version."\"></script>\n";
		}
		if ($version == "3.0" && get_option('wp_sh_legacy') == 0) {
			echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shAutoloader.js?ver=".$version."\"></script>\n";
			echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shBrushXml.js??ver=".$version."\"></script>\n";
		} elseif ($version == "3.0" && get_option('wp_sh_legacy') == 1) {
			echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shAutoloader.js?ver=".$version."\"></script>\n";
			$wp_sh_brush_files = get_option('wp_sh_brush_files');
			foreach($wp_sh_brush_files as $lang => $val){
				$brush_file = $val[0];
				$brush_ver = $val[2];
				$brush_enable = $val[3];
				if (($brush_ver == '3.0' || $brush_ver == '2.1' || $brush_ver == '1.5') && $brush_enable == 'true') {
					echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/".$brush_file."?ver=".$version."\"></script>\n";
				}
			}
			if (is_admin() && $wp_sh_brush_files[XML][3] == "false") {
				echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shBrushXml.js?ver=".$version."\"></script>\n";
			}
		} elseif ($version == "2.1") {
			$wp_sh_brush_files = get_option('wp_sh_brush_files');
			foreach($wp_sh_brush_files as $lang => $val){
				$brush_file = $val[0];
				$brush_ver = $val[2];
				$brush_enable = $val[3];
				if (($brush_ver == '2.1' || $brush_ver == '1.5') && $brush_enable == 'true') {
					echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/".$brush_file."?ver=".$version."\"></script>\n";
				}
			}
			if (is_admin() && $wp_sh_brush_files[PHP][3] == "false") {
				echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shBrushPhp.js?ver=".$version."\"></script>\n";
			}
			if (is_admin() && $wp_sh_brush_files[XML][3] == "false") {
				echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shBrushXml.js?ver=".$version."\"></script>\n";
			}
			do_action( 'wpsh_brush_for_2' ); //Action hook for developers
		}
		if ($version == "3.0") {
			echo "<script type=\"text/javascript\">//<![CDATA[
	SyntaxHighlighter.autoloader(\n";
			$wp_sh_brush_files = get_option('wp_sh_brush_files');
			$count = 0;
			foreach($wp_sh_brush_files as $lang => $val){
				$brush_file = $val[0];
				$brush_alias = $val[1];
				$brush_ver = $val[2];
				$brush_enable = $val[3];
				$count = $count + 1;
				if ($count == 1) {
					echo "	\"".$brush_alias."	".$wp_sh_plugin_url.$lib_dir."/scripts/".$brush_file."?ver=".$version."\"\n";
				} else {
					echo "	,\"".$brush_alias."	".$wp_sh_plugin_url.$lib_dir."/scripts/".$brush_file."?ver=".$version."\"\n";
				}
			}
			do_action( 'wpsh_brush_for_3' ); //Action hook for developers
			echo "	);
	SyntaxHighlighter.defaults['auto-links'] = ".$auto_links.";
	SyntaxHighlighter.defaults['class-name'] = '".get_option('wp_sh_class_name')."';
	SyntaxHighlighter.defaults['collapse'] = ".$collapse.";
	SyntaxHighlighter.defaults['first-line'] = ".get_option('wp_sh_first_line').";
	SyntaxHighlighter.defaults['gutter'] = ".$gutter.";
	SyntaxHighlighter.defaults['smart-tabs'] = ".$smart_tabs.";
	SyntaxHighlighter.defaults['tab-size'] = ".get_option('wp_sh_tab_size').";
	SyntaxHighlighter.defaults['toolbar'] = ".$toolbar.";\n";
			if (get_option('wp_sh_legacy') == 1) {
				echo "	SyntaxHighlighter.config.stripBrs = true;\n";
			}
			echo "	SyntaxHighlighter.config.strings.expandSource = '".__( '+ expand source', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.help = '".__( '?', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.alert = '".__( 'SyntaxHighlighter\n\n', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.noBrush = \"".__( 'Can\'t find brush for: ', 'wp_sh' )."\";
	SyntaxHighlighter.config.strings.brushNotHtmlScript = \"".__( 'Brush wasn\'t configured for html-script option: ', 'wp_sh' )."\";
	SyntaxHighlighter.all();
	".$legacy."
//]]></script>
<!-- WP SyntaxHighlighter Ver.".$wp_sh_ver." End -->\n";
		} elseif ($version == "2.1") {
			echo "<script type=\"text/javascript\">//<![CDATA[
	SyntaxHighlighter.config.clipboardSwf = '".$wp_sh_plugin_url.$lib_dir."/scripts/clipboard.swf';
	SyntaxHighlighter.defaults['auto-links'] = ".$auto_links.";
	SyntaxHighlighter.defaults['class-name'] = '".get_option('wp_sh_class_name')."';
	SyntaxHighlighter.defaults['collapse'] = ".$collapse.";
	SyntaxHighlighter.defaults['first-line'] = ".get_option('wp_sh_first_line').";
	SyntaxHighlighter.defaults['gutter'] = ".$gutter.";
	SyntaxHighlighter.defaults['smart-tabs'] = ".$smart_tabs.";
	SyntaxHighlighter.defaults['tab-size'] = ".get_option('wp_sh_tab_size').";
	SyntaxHighlighter.defaults['toolbar'] = ".$toolbar.";
	SyntaxHighlighter.defaults['wrap-lines'] = ".$wrap.";\n";
			if (get_option('wp_sh_legacy') == 1) {
				echo "	SyntaxHighlighter.config.stripBrs = true;\n";
			}
			echo "	SyntaxHighlighter.config.strings.expandSource = '".__( 'show source', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.viewSource = '".__( 'view source', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.copyToClipboard = '".__( 'copy to clipboard', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.copyToClipboardConfirmation = '".__( 'The code is in your clipboard now', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.print = '".__( 'print', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.help = '".__( '?', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.alert = '".__( 'SyntaxHighlighter\n\n', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.noBrush = \"".__( 'Can\'t find brush for: ', 'wp_sh' )."\";
	SyntaxHighlighter.config.strings.brushNotHtmlScript = \"".__( 'Brush wasn\'t configured for html-script option: ', 'wp_sh' )."\";
	SyntaxHighlighter.all();
	".$legacy."
//]]></script>
<!-- WP SyntaxHighlighter Ver.".$wp_sh_ver." End -->\n";
		}
	} else {
		echo '';
	}
}

//Setting panel
function wp_sh_options_panel(){
	global $wp_sh_plugin_url, $wp_sh_db_ver;
	if(!function_exists('current_user_can') || !current_user_can('manage_options')){
			die(__('Cheatin&#8217; uh?'));
	} 
	add_action('in_admin_footer', 'wp_sh_add_admin_footer');

	if (isset($_POST['WP_SH_Lang_submit'])) {
		echo "<div id='setting-error-settings_updated' class='updated fade'><p><strong>".__("Settings saved.","wp_sh")."</strong></p></div>";
	} elseif (isset($_POST['WP_SH_Reset'])) {
		echo "<div id='setting-error-settings_updated' class='updated fade'><p><strong>".__("All settings were reset. Please <a href=\"options-general.php?page=wp-syntaxhighlighter-options\">reload the page</a>.","wp_sh")."</strong></p></div>";
	}
	$wp_sh_current_language3 = get_option('wp_sh_language3');
	$wp_sh_current_language2 = get_option('wp_sh_language2');
	$wp_sh_current_brushes = get_option('wp_sh_brush_files');
	if ((!is_array($wp_sh_current_language3) || !is_array($wp_sh_current_language2) || !is_array($wp_sh_current_brushes) || $wp_sh_db_ver != get_option('wp_sh_checkver_stamp')) && !isset($_POST['WP_SH_Reset'])) {
		echo "<div id='setting-error-settings_updated' class='updated settings-error'><p><strong>".__("Error: Missing Database Table. The plugin may fail to create the databese table when install or update. Please re-create database table by clicking on 'Reset All Settings'.","wp_sh")."</strong></p></div>";
	}

	#Update brush files array.
	if(isset($_POST['WP_SH_Lang_submit'])){
		foreach($wp_sh_current_brushes as  $lang => $val){
			$brush_file = $val[0];
			$brush_alias = $val[1];
			$brush_ver = $val[2];
			$wp_sh_brush_files[$lang]= array($brush_file, $brush_alias, $brush_ver, $_POST[$lang]);
		}
	update_option('wp_sh_brush_files', $wp_sh_brush_files);
	}

	#Reset all settings
	if(isset($_POST['WP_SH_Reset']) && $_POST['wp_sh_reset']='true'){
		include_once('uninstall.php');
		wp_sh_array_setting();
		wp_sh_register_menu_item();
	}

	#When collapse activated
	if (get_option('wp_sh_collapse') == 1) {
		update_option('wp_sh_toolbar', 1);
	}
	?>
	<div class="wrap">
	<h2>WP SyntaxHighlighter</h2>
	<form method="post" action="options.php">
		<table style="margin-top:20px">
		<?php settings_fields('wp_sh_settings_group'); ?>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Library version', 'wp_sh') ?></th> 
				<td style="padding-left:10px">
					<select name="wp_sh_version">
						<option value="3.0" <?php if (get_option('wp_sh_version') == "3.0") {echo 'selected="selected"';} ?>>3.0.83</option>
						<option value="2.1" <?php if (get_option('wp_sh_version') == "2.1") {echo 'selected="selected"';} ?>>2.1.382</option>
					</select>
					<p><small><?php _e("Choose 'Syntax Highlighter' JavaScript library version.<br />In ver. 2.1, 'autoloader' will be disabled and <a href=\"#loaded_languages\">pre-selected language definition files</a> will be loaded at once.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Theme', 'wp_sh') ?></th> 
				<td style="padding-left:10px">
					<select name="wp_sh_theme">
						<option value="Default" <?php if (get_option('wp_sh_theme') == "Default") {echo 'selected="selected"';} ?>>Default</option>
						<option value="Django" <?php if (get_option('wp_sh_theme') == "Django") {echo 'selected="selected"';} ?>>Django</option>
						<option value="Eclipse" <?php if (get_option('wp_sh_theme') == "Eclipse") {echo 'selected="selected"';} ?>>Eclipse</option>
						<option value="Emacs" <?php if (get_option('wp_sh_theme') == "Emacs") {echo 'selected="selected"';} ?>>Emacs</option>
						<option value="FadeToGrey" <?php if (get_option('wp_sh_theme') == "FadeToGrey") {echo 'selected="selected"';} ?>>FadeToGrey</option>
						<option value="MDUltra" <?php if (get_option('wp_sh_theme') == "MDUltra") {echo 'selected="selected"';} ?>>MDUltra</option>
						<option value="Midnight" <?php if (get_option('wp_sh_theme') == "Midnight") {echo 'selected="selected"';} ?>>Midnight</option>
						<option value="RDark" <?php if (get_option('wp_sh_theme') == "RDark") {echo 'selected="selected"';} ?>>RDark</option>
					</select>
					<p><small><?php _e("Themes for the highlighted elements. 'MDUltra' is not available for ver. 2.1.<br />If you choose 'MDUltra' in ver. 2.1, Theme will be replaced with 'Defaut' theme.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Auto links', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<?php $auto_links_check = get_option('wp_sh_auto_links') ? ' checked="checked" ' : ''; ?>
					<input type="checkbox" name="wp_sh_auto_links" value="1" <?php echo $auto_links_check; ?>/>
					<p><small><?php _e('URL in the highlighted element will be linked by default.', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Class name', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<input type="text" name="wp_sh_class_name" value="<?php echo get_option('wp_sh_class_name') ?>" />
					<p><small><?php _e('Enter custom class name for addtional stylesheet. It will be added to code block.', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Style Sheet', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<?php $addl_style_enable_check = get_option('wp_sh_addl_style_enable') ? ' checked="checked" ' : ''; ?>
					<input type="checkbox" name="wp_sh_addl_style_enable" value="1" <?php echo $addl_style_enable_check; ?>/> <?php _e('Use additional CSS', 'wp_sh') ?><br />
					<textarea name="wp_sh_addl_style"  rows="8" style="width:500px"><?php echo get_option('wp_sh_addl_style') ?></textarea>
					<p><small><?php _e("Define additional CSS for code block. The defined CSS will be inserted into <code>&lt;head&gt;</code> section.<br />You can also use the class defined by 'Class name' option.", 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Collapse', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<?php $collapse_check = get_option('wp_sh_collapse') ? ' checked="checked" ' : ''; ?>
					<input type="checkbox" name="wp_sh_collapse" value="1" <?php echo $collapse_check; ?>/>
					<p><small><?php _e("The code box will be collapsed by default. If you want to use this option, 'Toolbar' option must be enabled. ", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Line number(Gutter)', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<?php $gutter_check = get_option('wp_sh_gutter') ? ' checked="checked" ' : ''; ?>
					<input type="checkbox" name="wp_sh_gutter" value="1" <?php echo $gutter_check; ?>/>
					<p><small><?php _e('Line number(Gutter) will be shown by default.', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Starting line number', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<input type="text" name="wp_sh_first_line" size="2" value="<?php echo get_option('wp_sh_first_line') ?>" />
					<p><small><?php _e('Enter starting line number for the line numbering(Gutter).', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Smart tabs', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<?php $smart_tabs_check = get_option('wp_sh_smart_tabs') ? ' checked="checked" ' : ''; ?>
					<input type="checkbox" name="wp_sh_smart_tabs" value="1" <?php echo $smart_tabs_check; ?>/>
					<p><small><?php _e("Indent by 'tab' will be optimized by default.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Tab size', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<input type="text" name="wp_sh_tab_size" size="2" value="<?php echo get_option('wp_sh_tab_size') ?>" />
					<p><small><?php _e("Tab size for 'Smart tabs' feature.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Toolbar', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<?php $toolbar_check = get_option('wp_sh_toolbar') ? ' checked="checked" ' : ''; ?>
					<input type="checkbox" name="wp_sh_toolbar" value="1" <?php echo $toolbar_check; ?>/>
					<p><small><?php _e('Toolbar will be shown by default.', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Wrap lines', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<?php $wrap_check = get_option('wp_sh_wrap') ? ' checked="checked" ' : ''; ?>
					<input type="checkbox" name="wp_sh_wrap" value="1" <?php echo $wrap_check; ?>/>
					<p><small><?php _e('Only for ver. 2.1. Long lines will be wrapped automatically by default.', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Legacy mode', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<?php $legacy_check = get_option('wp_sh_legacy') ? ' checked="checked" ' : ''; ?>
					<input type="checkbox" name="wp_sh_legacy" value="1" <?php echo $legacy_check; ?>/>
					<p><small><?php _e("Support <a href=\"http://code.google.com/p/syntaxhighlighter/wiki/Usage\">old style 'pre' tag</a> in ver. 1.5. As a result, <a href=\"#loaded_languages\">pre-selected language definition files</a> will be loaded at once.<br />The 'autoloader' too will be still active in ver. 3.0. However 'autoloader' can't support old style 'pre' tag.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('CSS for <code>&lt;pre&gt;</code> tag', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<?php $css_check = get_option('wp_sh_css') ? ' checked="checked" ' : ''; ?>
					<input type="checkbox" name="wp_sh_css" value="1" <?php echo $css_check; ?>/>
					<p><small><?php _e("If it is some time before your code highlighted, Unbeautiful code block will appear for a while.<br />This CSS will define its visual layout. Your code block may look some more good.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('TinyMCE Buttons', 'wp_sh') ?></th>
				<td style="padding-left:10px">
					<?php $insert_check = get_option('wp_sh_insert') ? ' checked="checked" ' : ''; ?>
					<?php $codebox_check = get_option('wp_sh_codebox') ? ' checked="checked" ' : ''; ?>
					<input type="checkbox" name="wp_sh_insert" value="1" <?php echo $insert_check; ?>/> Select &amp; Insert <input type="checkbox" name="wp_sh_codebox" value="1" <?php echo $codebox_check; ?>/> Codebox
					<p><small><?php _e("Enable/Disable TinyMCE Buttons. They can help you to type <code>&lt;pre&gt;</code> tag in 'Visual Editor'.<br />'Select &amp; Insert' will help you to wrap your code on the post or page in <code>&lt;pre&gt;</code> tag or to update values of previously-markuped code.<br />'CodeBox' will allow you to paste your code into the post or page, keeping indent by tabs. Your pasted code will be warpped in <code>&lt;pre&gt;</code> tag automatically.<br/ >In 'Visual Editor', 'Select &amp; Insert' will appear as 'pre' icon and 'CodeBox' will appear as 'CODE' icon.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Window size', 'wp_sh') ?></th> 
				<td style="padding-left:10px">
					<select name="wp_sh_button_window_size">
						<option value="100" <?php if (get_option('wp_sh_button_window_size') == "100") {echo 'selected="selected"';} ?>>100%</option>
						<option value="105" <?php if (get_option('wp_sh_button_window_size') == "105") {echo 'selected="selected"';} ?>>105%</option>
						<option value="110" <?php if (get_option('wp_sh_button_window_size') == "110") {echo 'selected="selected"';} ?>>110%</option>
					</select>
					<p><small><?php _e("Choose size of pop-up window at the click of buttons.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" align="right"><?php _e('Place the buttons in', 'wp_sh') ?></th> 
				<td style="padding-left:10px">
					<select name="wp_sh_button_row">
						<option value="1" <?php if (get_option('wp_sh_button_row') == "1") {echo 'selected="selected"';} ?>><?php _e("1st row", "wp_sh") ?></option>
						<option value="2" <?php if (get_option('wp_sh_button_row') == "2") {echo 'selected="selected"';} ?>><?php _e("2nd row", "wp_sh") ?></option>
						<option value="3" <?php if (get_option('wp_sh_button_row') == "3") {echo 'selected="selected"';} ?>><?php _e("3rd row", "wp_sh") ?></option>
						<option value="4" <?php if (get_option('wp_sh_button_row') == "4") {echo 'selected="selected"';} ?>><?php _e("4th row", "wp_sh") ?></option>
					</select> <?php _e("of TinyMCE toolbar.", "wp_sh") ?>
					<p><small><?php _e("Choose TinyMCE toolbar row which buttons will be placed in.", "wp_sh") ?></small></p>
				</td>
			</tr>
		</table>
		<p class="submit">
		<input type="submit" name="Submit" value="<?php _e('Save Changes', 'wp_sh') ?>" />
		</p>
	</form>
	<div style="margin-left:20px; margin-top:20px"><a href="javascript:showhide('id1');" name="loaded_languages"><?php _e("Show Optional settings for ver. 2.1 or 'Legacy mode'", 'wp_sh') ?></a></div>
	<div id="id1" style="display:none; margin-left:20px">
	<h3><?php _e("Pre-loaded languages for ver. 2.1 or 'Legacy mode'.", 'wp_sh') ?></h3>
		<?php 
		$wp_sh_brush_files = get_option('wp_sh_brush_files');
		if (is_array($wp_sh_brush_files)) {
		?>
	<form method="post" action="<?php echo($_SERVER['REQUEST_URI']);?>">
		<table>
			<tr valign="top"> 
				<th scope="row" align="right"></th>
				<td style="padding-left:10px">
					<p><small><?php _e("Choose pre-loaded languages. Remember to save by clicking on 'Save Your Languages' button below.<br />Notes: After automatic-update, the default settings will be restored.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<?php
			foreach($wp_sh_brush_files as $lang => $val){
				$brush_ver = $val[2];
				$brush_enable = $val[3];
				if ($brush_ver == '3.0' || $brush_ver == '2.1' || $brush_ver == '1.5') {
			?>
			<tr valign="top">
				<th scope="row" align="right"><?php echo $lang.'(ver.'.$brush_ver.')'; ?></strong></th>
				<td style="padding-left:10px; padding-bottom:5px">
				<label for="<?php echo $lang; ?>_Yes"> <input type="radio" id="<?php echo $lang; ?>_Yes" name="<?php echo $lang; ?>" value="true" <?php if($brush_enable == 'true'){echo 'checked="checked"';}?> /><?php _e('Yes', 'wp_sh') ?></label>
				<label for="<?php echo $lang; ?>_No"><input type="radio" id="<?php echo $lang; ?>_No" name="<?php echo $lang; ?>" value="false" <?php if($brush_enable == 'false'){echo 'checked="checked"';}?> /><?php _e('No', 'wp_sh') ?></label>
				</td>
			</tr>
				<?php }
			} ?>
		</table>
		<p class="submit">
		<input type="submit" name="WP_SH_Lang_submit" value="<?php _e('Save Your Languages', 'wp_sh') ?>" />
		</p>
	</form>
		<?php } ?>
	</div>
	<form method="post" action="<?php echo($_SERVER['REQUEST_URI']);?>" onsubmit="return confirmreset()">
		<table>
			<tr valign="top">
				<td style="padding-left:10px">
					<input type="hidden" name="wp_sh_reset" value="true" />
				</td>
			</tr>
		</table>
		<p class="submit">
		<input type="submit" name="WP_SH_Reset" value="<?php _e('Reset All Settings', 'wp_sh') ?>" />
		</p>
	</form>
	<h3><?php _e('Your Current Theme', 'wp_sh') ?></h3>
	<div style="width:600px; margin-left:20px">
	<pre class="brush: php; html-script: true; highlight: 9">
	&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;
	&lt;html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en"&gt;
	&lt;head&gt;
		&lt;meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /&gt;
		&lt;title&gt;Syntax Highlighting Example&lt;/title&gt;
	&lt;/head&gt;
	&lt;body style="width:500px"&gt;
		&lt;h1&gt;Syntax Highlighting Example&lt;/h1&gt;
		&lt;p&gt;&lt;?php echo 'Hello World!' ?&gt;&lt;/p&gt;
		&lt;p&gt;XHTML with PHP script.&lt;/p&gt;
		&lt;div class="tabs"&gt;
  			TAB	TAB		TAB	TAB
				TAB	TAB	TAB		TAB
			TAB		TAB		TAB	TAB
		&lt;p&gt;For 'Smart tabs'.&lt;/p&gt;
		&lt;/div&gt;

		&lt;p&gt;http://wordpress.org/&lt;/p&gt;
	&lt;/body&gt;
	&lt;/html&gt;</pre>
	</div>
	<h3><a href="javascript:showhide('id2');" name="system_info"><?php _e("Show Your System Info", 'wp_sh') ?></a></h3>
	<div id="id2" style="display:none; margin-left:20px">
	<p>
	<?php _e('Server OS:', 'wp_sh') ?> <?php echo php_uname('s').' '.php_uname('r'); ?><br />
	<?php _e('PHP version:', 'wp_sh') ?> <?php echo phpversion(); ?><br />
	<?php _e('MySQL version:', 'wp_sh') ?> <?php echo mysql_get_server_info(); ?><br />
	<?php _e('WordPress version:', 'wp_sh') ?> <?php bloginfo("version"); ?><br />
	<?php _e('Site URL:', 'wp_sh') ?> <?php bloginfo("url"); ?><br />
	<?php _e('WordPress URL:', 'wp_sh') ?> <?php bloginfo("wpurl"); ?><br />
	<?php _e('WordPress language:', 'wp_sh') ?> <?php bloginfo("language"); ?><br />
	<?php _e('WordPress character set:', 'wp_sh') ?> <?php bloginfo("charset"); ?><br />
	<?php _e('WordPress theme:', 'wp_sh') ?> <?php $wp_sh_theme = get_theme(get_current_theme()); echo $wp_sh_theme['Name'].' '.$wp_sh_theme['Version']; ?><br />
	<?php _e('WP SyntaxHighlighter version:', 'wp_sh') ?> <?php $wp_sh_plugin_data = get_plugin_data(__FILE__); echo $wp_sh_plugin_data['Version']; ?><br />
	<?php _e('WP SyntaxHighlighter DB version:', 'wp_sh') ?> <?php echo get_option('wp_sh_checkver_stamp'); ?><br />
	<?php _e('WP SyntaxHighlighter URL:', 'wp_sh') ?> <?php echo $wp_sh_plugin_url; ?><br />
	<?php _e('Your browser:', 'wp_sh') ?> <?php echo $_SERVER['HTTP_USER_AGENT']; ?>
	</p>
	</div>
	<p>
	<?php _e("To report a bug ,submit requests and feedback, ", 'wp_sh') ?><?php _e('Use <a href="http://wordpress.org/tags/wp-syntaxhighlighter?forum_id=10">Forum</a> or <a href="http://www.near-mint.com/blog/contact">Mail From</a>', 'wp_sh') ?>
	</p>
<?php }
?>